<template>
  <div class="topic-detail">
    <LoadingSpinner v-if="loading" />
    <div v-if="loaded">
      <router-link v-if="canEditThisTopic" :to="editTopicRoute" class="btn btn-primary me-2">
        Edit
        <i class="bi bi-pencil-fill"></i>
      </router-link>
      <TopicSubscriptionButton
        v-if="userId && topic"
        :topic="topic"
        @subscribed="onSubscribed"
        @unsubscribed="onUnsubscribed"
      />
      <p>{{ topic?.subHeading }}</p>
    </div>
  </div>
</template>

<script>
import { ref, computed, onMounted } from 'vue'
import { useStore } from 'vuex'
import { LoadingSpinner, useApi, useNotification } from '../../core'
import { useAuth } from '../../identity'
import TopicsApi from '../api/topics-api.js'
import TopicSubscriptionButton from './topic-subscription-button.vue'

export default {
  name: 'TopicDetail',
  emits: ['subscribed', 'unsubscribed', 'loaded'],
  components: {
    LoadingSpinner,
    TopicSubscriptionButton,
  },
  props: {
    alias: { type: String, default: '' },
    topic: { type: Object, default: null },
  },
  setup(props, context) {
    const store = useStore()
    const api = useApi()
    const auth = useAuth()
    const notify = useNotification()
    const topicsApi = new TopicsApi(api, auth)

    const loading = ref(false)
    const loaded = ref(false)

    const route = computed(() => {
      return props.alias ? { name: 'forum-topic', params: { alias: props.alias } } : null
    })

    const isTopicOwner = computed(() => {
      return (
        store.state.identity.session.userId && props.topic && store.state.identity.session.userId === props.topic.userId
      )
    })

    const canEditThisTopic = computed(() => {
      return isTopicOwner.value || store.state.identity.session.roles.includes('Moderator')
    })

    const editTopicRoute = computed(() => {
      return props.alias ? { name: 'forum-topic-edit', params: { alias: props.alias } } : null
    })

    const onSubscribed = (id) => {
      context.emit('subscribed', id)
    }

    const onUnsubscribed = (id) => {
      context.emit('unsubscribed', id)
    }

    const loadAsync = async () => {
      loading.value = true
      loaded.value = false

      try {
        const response = await topicsApi.readAsync(props.alias, { expand: 'all' })
        loaded.value = true
        context.emit('loaded', response.data)
      } catch (ex) {
        notify.error('There was a problem getting the topic.', ex)
      } finally {
        loading.value = false
      }
    }

    onMounted(async () => {
      await loadAsync()
    })

    return {
      loading,
      loaded,
      route,
      isTopicOwner,
      canEditThisTopic,
      editTopicRoute,
      onSubscribed,
      onUnsubscribed,
    }
  },
}
</script>
